<?php
//#################################################################################################
//	Installpage class
//#################################################################################################
//	chillyCMS - Content Management System
//	Copyright (C) 2008
//	Stefanie Wiegand <wiegand.stefanie@gmail.com> & Johannes Cox <johannes.cox@gmail.com>
//	
//	This program is licensed under the GPL 3.0 license. For more information see LICENSE.txt.
//#################################################################################################
defined('DOIT') or die('Restricted access');

require_once('page.class.php');
		
class Installpage extends Page {
	//Class variables//////////////////////////////////////////////////////////////////////////
	public $language;			//active language
	public $pagetitle;
	protected $stylesheets;			//the stylesheets of the modules used in the site
	protected $countme;			//count the visit of the pagecall?
	//Functions////////////////////////////////////////////////////////////////////////////////
	//Constructor
	function __construct() {
		global $settings;
		
		parent::__construct();
		
		$this->title = 'chillyCMS Installation';
	
		//doctype
		$this->doctype = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" ".
		"\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n".
		"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"".$this->language."\" ".
		"lang=\"".$this->language."\">\n".
		"<head>\n";

		//metatags
		$this->meta .= 
		"<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\" />".//TODO
		"\t<meta name=\"author\" content=\"chillyCMS\" />\n".
		"\t<meta name=\"keywords\" content=\"installation,chillyCMS\" />\n".
		"\t<meta name=\"description\" content=\"This is the chillyCMS installation routine.\" />\n".
		"\t<meta name=\"robots\" content=\"noindex,nofollow\" />\n".
		"\t<link rel=\"icon\" href=\"../style/images/favicon.ico\" type=\"image/vnd.microsoft.icon\" />\n";
		
		//stylesheets
		$this->stylesheets = "\t<link rel='stylesheet' href='".URL."/style/css/blue.css' type='text/css' />\n".
		"\t<link rel='stylesheet' href='".URL."/style/css/backend.css' type='text/css' />\n".
		"\t<link rel='stylesheet' href='".URL."/style/css/frontend.css' type='text/css' />\n".
		"\t<link rel='stylesheet' href='".URL."/style/css/install.css' type='text/css' />\n";
	}
	
	function print_head() {
		echo $this->doctype.
		"<title>$this->title</title>\n".
		$this->meta.
		$this->stylesheets.
		'</head>';
	}
	
	function print_body($msg) {
	
		echo "<body>
		<div class='wrapper'>
		<div class='wrapper_top'>
			<div class='wrapper_top_left'></div>
			<div class='wrapper_top_middle'>\n".
			msg($msg).
			"\t\t</div>
			<div class='wrapper_top_right'></div>
		</div>
		<div class='clr'></div>
		<div class='admincontent'>\n".
		$this->content.
		"\t</div>\n".
			"\t<div class='clr backendbottom'></div>\n".
			"\t<div class='push'></div>\n".
		"</div>\n".
		"</div>\n".
		"<div class='footer_full'>\n".
			"\t<div class='footer'>\n".
				"\t\t<div class='footer_inner'>\n".
					"\t\t\t<p class='footerleft'>chillyCMS &copy;2008 - ".date("Y").
					" Stefanie Wiegand &amp; Johannes Cox</p>\n".
					"\t\t\t<p class='footerright'>".
					"<a href='".URL."/admin/credits.site.php'>More Credits</a></p>\n".
				"\t\t</div>\n".
			"\t</div>\n".
		"</div>\n".
		"</body>\n".
		"</html>\n";

	}

	//Destructor
	public function __destruct() {
		$this->language=$this->pagetitle=$this->author=$this->siteemail=$this->backendstyle=$this->template=
		$this->keywords=$this->description=$this->positions=$this->id=$this->name=$this->mainmodname=$this->settings=
		$this->access=$this->specialaccess=$this->content=$this->submodules=$this->stylesheets=$this->countme=false;
		
		parent::__destruct();
	}
	
	//Getter
	public function __get($name) {
		if (isset($name, $this->$name)) { return $this->$name; }
		else { return false; }	
	}
	
	//Setter
	public function __set($name,$value) {
		if (isset($name, $this->$name)) { $this->$name=$value; }
		else { return false; }	
	}
}
?>
