drop table if exists mod_bugtrap_dialogue;
drop table if exists mod_bugtrap;

create table mod_bugtrap (
`id`		int		not null	auto_increment		,
`mainmodid`	int		not null				, -- project id
`name`		varchar(50)						,
`insertdate`	datetime	not null				,
`state`		int							,
`type`		int							,
`description`	text							, -- only to be filled at creation
`comment`	varchar(255)						, -- programmer's comments after closing
`reporter`	int							, -- uid of the user to report the bug, null = guest
`responsible`	int							, -- uid of the programmer in charge, null = none yet
`severity`	int							,
primary key (`id`),
CONSTRAINT modbugtrap_mainmodid_sitecontent_id_fk FOREIGN KEY(mainmodid) REFERENCES site_content(id) on delete cascade,
CONSTRAINT modbugtrap_reporter_systemusers_uid_fk FOREIGN KEY(reporter) REFERENCES system_users(uid) on delete set null,
CONSTRAINT modbugtrap_responsible_systemusers_uid_fk FOREIGN KEY(responsible) REFERENCES system_users(uid) on delete set null
) engine= innodb character set latin1 collate latin1_general_ci;

create table mod_bugtrap_dialogue (
`id`		int		not null	auto_increment		,
`bugid`		int		not null				, -- bug id
`uname`		varchar(50)						,
`date`		datetime	not null				,
`statement`	text							,
primary key (`id`),
CONSTRAINT modbugtrap_dialogue_bugid_modbugtrap_id_fk FOREIGN KEY(`bugid`) REFERENCES mod_bugtrap(`id`) on delete cascade
) engine= innodb character set latin1 collate latin1_general_ci;
